// Java imports
import java.io.*;

// Project imports
import app.*;
import util.*;
import vue.*;

// Desktop application primary class
public class Main {

    // Program entry point
    public static void main(String[] args) {

        // Configure Swing look-and-feel
        Util.setSystemLAF();

        // Load the native module, if available
        for (String filename : Util.listFiles("native")) {
            File file = null;

            // Skip .gitignore
            if (filename.equals(".gitignore"))
                continue;

            // Write the contents of the native object file
            FileOutputStream stream = null;
            try {
                file   = File.createTempFile("native", "." + filename);
                stream = new FileOutputStream(file);
                stream.write(Util.fileRead("native/" + filename));
            } catch (Exception e) { file = null; }
            try { stream.close(); } catch (Exception e) { }

            // Load the native object file into the JVM
            try { System.load(file.getAbsolutePath()); break; }
            catch (Error e) { }
        }

        // Begin application operations
        new App();

        var vue = VUE.create(true);
        System.out.println(vue.isNative());
    }

}
