package vue;

// Native-backed emulation core implementation
class NativeVUE implements VUE {

    // Instance fields
    private byte[] pointer; // Instance address in native memory



    ///////////////////////////////////////////////////////////////////////////
    //                             Constructors                              //
    ///////////////////////////////////////////////////////////////////////////

    // Default constructor
    NativeVUE() {
    }



    ///////////////////////////////////////////////////////////////////////////
    //                            Package Methods                            //
    ///////////////////////////////////////////////////////////////////////////

    // Determine whether the native library has been loaded
    static boolean isLoaded() {
        try { return testNative(); }
        catch (Exception e) { return false; }
    }



    ///////////////////////////////////////////////////////////////////////////
    //                            Public Methods                             //
    ///////////////////////////////////////////////////////////////////////////

    // Retrieve a copy of the ROM data
    public native byte[] getROM();

    // Determine whether the context is native-backed
    public native boolean isNative();

    // Provide new ROM data
    public native boolean setROM(byte[] data, int offset, int length);



    ///////////////////////////////////////////////////////////////////////////
    //                            Private Methods                            //
    ///////////////////////////////////////////////////////////////////////////

    // Invoke native code to ensure the module is loaded
    private static native boolean testNative();

}
