package vue;

// Template for emulation core implementations
public interface VUE {

    ///////////////////////////////////////////////////////////////////////////
    //                            Factory Methods                            //
    ///////////////////////////////////////////////////////////////////////////

    // Produce an emulation core context
    public static VUE create(boolean useNative) {
        return !useNative ? new JavaVUE() :
            NativeVUE.isLoaded() ? new NativeVUE() : null;
    }



    ///////////////////////////////////////////////////////////////////////////
    //                            Public Methods                             //
    ///////////////////////////////////////////////////////////////////////////

    // Retrieve a copy of the ROM data
    byte[] getROM();

    // Determine whether the context is native-backed
    boolean isNative();

    // Provide new ROM data
    boolean setROM(byte[] data, int offset, int length);

}
